const mongoose = require('mongoose-bird')(require('mongoose'));
var Schema = mongoose.Schema;


var quizSessionSchema = new Schema({

  aborted_at: Date,

  app: String,
  app_version: String,
  closed_at: Date,
  correctness_rate: Number,

  last_input_at: {type: Date, default: Date },


  opened_at: {type: Date, default: Date },
  players_count: {type: Number, default: 1},
  quiz: { type: String, ref: 'Quiz' },
  quiz_title: String,
  quiz_thumbnail_uri: String,

  results_by_players: { type: Schema.Types.Mixed, default: { } },
  score: Number,
  time: Number,
  track_performance: {type: Boolean, default: false},


  user: { type: Schema.Types.ObjectId, ref: 'User' }
});

quizSessionSchema.methods.valid = function() {
	if (!this.quiz_title) {
		return false;
	}
  if (!this.quiz) {
		return false;
	}
  if (!this.user) {
		return false;
	}
	return true;
}


module.exports = mongoose.model("QuizSession", quizSessionSchema);
