var mongoose = require('mongoose');
var Schema = mongoose.Schema;

const Answer = require('./answer');


var quizSessionInputSchema = new Schema({
  answer: { type: Schema.Types.ObjectId, ref: 'Answer' },
  benchmarkable: {type: Boolean, default: false},
  correct: {type: Boolean, default: false},


  opened_at: {type: Date, default: Date },
  player_number:  Number,
  question: { type: Schema.Types.ObjectId, ref: 'Question' },
  quiz_session: { type: Schema.Types.ObjectId, ref: 'QuizSession' },

  score: Number,
  submitted_at: {type: Date, default: Date },

  time: Number



});


quizSessionInputSchema.pre('save', function(next) {
  //set correct based on answer
  Answer.findOne({_id:this.answer}).exec().then((answer)=>{
      this.correct =  (answer.question.toString() == this.question.toString() && answer.right)
      next();
  })
});


quizSessionInputSchema.methods.valid = function() {
	if (!this.question) {
		return false;
	}
  if (!this.quiz_session) {
		return false;
	}
	return true;
}


module.exports = mongoose.model("QuizSessionInput", quizSessionInputSchema);
