// var mongoose = require('mongoose');
const mongoose = require('mongoose-bird')(require('mongoose'));
var Schema = mongoose.Schema;


var async = require('async');
var Crypto = require('crypto')

var userSchema = new Schema({

  authentication_token: String,
  email: String,
  provided_id: String,
  provider_name: {type: String,default: "local"},
  username:  String
},
{
  timestamps: { createdAt: 'created_at', updatedAt: 'updated_at' }
});

userSchema.pre('save', function(next) {
  //set correct based on answer
  var that = this
  var model = mongoose.model("User", userSchema);
  if(this.isNew){

    var unique = false
    async.whilst(function () {
      return unique == false;
    },
    function (n) {
      var token = Crypto.randomBytes(16).toString('hex');

      model.findOneAsync({authentication_token: token}).spread((user) => {

        if(!user){
          that.authentication_token = token
          unique = true
          next();
        }
        n();
      },(err)=>{
        console.log("err",err);
      })
    },
    function (err) {
      // All things are done!
    });


  }


});

userSchema.methods.valid = function() {
	if (!this.username) {
		return false;
	}
	return true;
}


module.exports = mongoose.model("User", userSchema);
